Summary: ProFTPd -- Professional FTP Server.
Name: proftpd
Version: 1.2.10
Release: 13tr
License: GPL
Group: Trustix Official
URL: http://www.proftpd.org/
Source0: ftp://ftp.proftpd.org/distrib/source/%{name}-%{version}.tar.bz2
Source1: proftpd.conf
Source2: proftpd.init
Source3: proftpd.ftpusers
Patch0: proftpd-1.2.6-init.patch
Patch1: proftpd-1.2.8-upload.patch
Patch2: proftpd-1.2.9-acl.patch
Patch3: proftpd-1.2.10-CAN-2005-2390.patch
Patch4: proftpd-1.3.0-sec.patch
Patch5: proftpd-1.3.0-mod_tls.patch
Patch6: proftpd-1.2.10-CVE-2006-5815.patch
Patch7: proftpd-CVE-2006-6563.patch
BuildRoot: /var/tmp/%{name}-root
Requires: pam >= 0.59, chkconfig, openssl
BuildRequires: pam-devel, openssl-devel , tcp_wrappers
Provides: ftpserver
Prereq: coreutils gawk setup sed /sbin/chkconfig /sbin/restart_maybe

%description
ProFTPd is an enhanced FTP server with a focus toward simplicity,
security, and ease of configuration.  It features a very Apache-like
configuration syntax, and a highly customizable server infrastructure,
including support for multiple 'virtual' FTP servers, anonymous FTP, and
permission-based directory visibility.

%prep
%setup -q
%patch0 -p1
#%patch1 -p1
#%patch2 -p0
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p0

%build
./configure \
            --prefix=/usr \
            --sysconfdir=/etc \
            --localstatedir=/var/run \
            --enable-sendfile \
            --with-openssl-dir=/usr \
            --with-modules=mod_rewrite:mod_ifsession:mod_ratio:mod_tls:mod_readme:mod_auth_pam:mod_wrap \
            --mandir=/usr/share/man \
            CFLAGS="$RPM_OPT_FLAGS"

make CFLAGS="$RPM_OPT_FLAGS -DPR_PROFTPD"

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

make \
    prefix=$RPM_BUILD_ROOT%{_prefix} \
    exec_prefix=$RPM_BUILD_ROOT%{_prefix} \
    localstatedir=$RPM_BUILD_ROOT/var/run \
    localstatedir=$RPM_BUILD_ROOT/var/run \
    rundir=$RPM_BUILD_ROOT/var/run/proftpd \
    mandir=$RPM_BUILD_ROOT/usr/share/man \
    sysconfdir=$RPM_BUILD_ROOT/etc \
install

install -d -m 755 $RPM_BUILD_ROOT/etc/pam.d
install -d -m 755 $RPM_BUILD_ROOT/etc/init.d
install -d -m 755 $RPM_BUILD_ROOT/var/log
touch $RPM_BUILD_ROOT/var/log/proftpd
chmod 644 $RPM_BUILD_ROOT/var/log/proftpd


install -m 644 contrib/dist/rpm/ftp.pamd $RPM_BUILD_ROOT/etc/pam.d/ftp
install -m 644 %SOURCE1 $RPM_BUILD_ROOT/etc/proftpd.conf
install -m 755 %SOURCE2 $RPM_BUILD_ROOT/etc/init.d/proftpd
install -m 644 %SOURCE3 $RPM_BUILD_ROOT/etc/ftpusers

%preun
# nuke everyting only on 'rpm -e proftpd' 
if [ $1 = 0 ]; then
    %{_initdir}/proftpd stop >&2
    service proftpd stop
    /sbin/chkconfig --del proftpd
    rm -rf /var/run/proftpd/*
fi

%pre
# don't remove but keep it aside
if [ -d /var/log/proftpd ]; then
    mv /var/log/proftpd /var/log/proftpd.old
fi

%post
# Make correct symlinks.
/sbin/chkconfig --add proftpd
# Restart service after upgrade.
/sbin/restart_maybe proftpd

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,0755)
%doc README README.* doc/*
%doc contrib/README contrib/README.* contrib/xferstats.holger-preiss
%doc sample-configurations/*
%config(noreplace) /etc/proftpd.conf
%config(noreplace) /etc/ftpusers
%config(noreplace) /etc/pam.d/ftp
/usr/share/man/*/*
/usr/sbin/*
/usr/bin/*
%dir /var/run/proftpd
/var/log/proftpd
/etc/init.d/proftpd

%changelog
* Mon Dec 18 2006 Nived Gopalan <nived at trustix dot org> 1.2.10-13tr
- SECURITY Fix: Alfredo Ortega has reported a vulnerability in the
  mod_ctrls module for ProFTPD, caused due to a boundary error within
  the "pr_ctrls_recv_request()" function in src/ctrls.c. This can be
  exploited to cause a buffer overflow by sending specially crafted
  control messages to the module.

  The Common Vulnerabilities and Exposures project (cve.mitre.org)
  has assigned the name CVE-2006-6563 to this issue.

* Wed Dec 06 2006 Bipin S <bipin at trustix dot org> 1.2.10-12tr
- SECURITY Fix: Stack-based buffer overflow in the sreplace function
  allows remote attackers to cause a denial of service, as demonstrated
  by vd_proftpd.pm, a "ProFTPD remote exploit."
                                                                                                                             
  The Common Vulnerabilities and Exposures project (cve.mitre.org)
  has assigned the name CVE-2006-5815 to this issue.
                                                                                                                             
- NOTE: In November 2006, the role of CommandBufferSize was originally
  associated with CVE-2006-5815, but this was an error stemming from
  an initial vague disclosure. Correct CVE: CVE-2006-6171.

* Mon Nov 27 2006 Nived Gopalan <nived at trustix dot org> 1.2.10-11tr
- Security Fix for mod_tls. 

* Thu Nov 23 2006 Nived Gopalan <nived at trustix dot org> 1.2.10-10tr
- SECURITY Fix: Evgeny Legerov has reported a vulnerability in ProFTPD,
  caused due to a buffer overflow error in the "main.c" file where the
  "cmd_buf_size" size of the buffer used to handle FTP commands sent
  by clients is not properly set to the size configured via the
  "CommandBufferSize" directive. This can be exploited by malicious
  people to compromise a vulnerable system.

  The Common Vulnerabilities and Exposures project (cve.mitre.org)
  has assigned the name CVE-2006-5815 to this issue.

* Tue Aug 02 2005 Syed Shabir Zakiullah <syedshabir at comodo dot com> 1.2.10-9tr
- Security Fix: Format string vulnerabilities
- Two vulnerabilities have been reported in ProFTPD, which can be
  exploited by malicious users to disclose certain sensitive
  information, cause a DoS (Denial of Service), or potentially
  compromise a vulnerable system.

  The Common Vulnerabilities and Exposures project (cve.mitre.org)
  has assigned the name CAN-2005-2390 to this issue

* Mon May 09 2005 Ajith Thampi <ajith at comodo dot com> 1.2.10-8tr
- Keep the /var/log/proftd aside and not remove it
- Service proftpd needs to be stopped in %preun

* Mon May 09 2005 Ajith Thampi <ajith at comodo dot com> 1.2.10-7tr
- Its /var/log/proftp'd' directory removal in %pre
 		
* Wed May 04 2005 Ajith Vargese Thampi <ajith at comodo dot com> 1.2.10-6tr
- Retracking Bug #450, Fixing service starting issue and other small issues.
  updated to a previous working spec	

* Tue Nov  9 2004 Oystein Viggen <oysteivi at trustix dot com>  1.2.10-2tr
- Rebuild with shared openssl

* Tue Sep 21 2004 Ajith Thampi <ajith at comodo dot com> 1.2.10-1tr
- New Upstream.
- Removed patch2
- Additional module mod_wrap introduced.

* Fri Apr 30 2004 Oystein Viggen <oysteivi at trustix dot com> 1.2.9-7tr
- Patch bug with cidr acl entries

* Mon Mar  1 2004 Erlend Midttun <erlendbm at trustix dot org> 1.2.9-5tr
- Removed ldap and mysql requirement.

* Sun Jan 25 2004 Erlend Midttun <erlendbm at trustix dot org> 1.2.9-3tr
- Adapted for Trustix 2.1.

* Wed Dec  3 2003 Erlend Midttun <erlendbm at trustix dot org> 1.2.9-2tr
- Big rebuild

* Thu Nov 20 2003 Tor Hveem <torh at trustix dot org> 1.2.9-1th
- New upstream version
- Removed patch1
- Included some more modules and added som BuilReqs

* Sun Sep 28 2003 Chr. Toldnes <christht at tawie dot org> 1.2.8-10tsl
- port to tawie

* Wed Sep 24 2003 Chr. Toldnes <christht at tslng dot org> 1.2.8-9tr
- Retagged and rebuilt

* Tue Sep 23 2003 Goetz Bock <bock at trustix dot org> 1.2.8-8bg
- added patch (well diff) for upload bug from 1.2.8p

* Mon Jun 23 2003 Erlend Midttun <erlendbm at trustix dot com> 1.2.8-7tr
- Added %defattr.

* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot com> 1.2.8-6tr
- Big rebuild

* Tue Jun 10 2003 Erlend Midttun <erlendbm at trustix dot com> 1.2.8-5em
- Remove anonftp Req.

* Sat Jun  7 2003 Erlend Midttun <erlendbm at trustix dot com> 1.2.8-4em
- Removed /home/ftp, Req anonftp to fix file conflict.

* Mon May 26 2003 Erlend Midttun <erlendbm at trustix dot com> 1.2.8-3em
- fileutils -> coreutils.

* Mon Mar 24 2003 Erlend Midttun <erlendbm at trustix dot com> 1.2.8-2em
- Rebuilt against glibc 2.3.2.

* Wed Mar 19 2003 Tor Hveem <torh at trustix dot org> 1.2.8-1th
- 1.2.8
- removed TSL patch.
- fixed pam module name.
- added lots of deps.

* Fri Feb 28 2003 Erlend Midttun <erlendbm at trustix dot com> 1.2.6-5em
- Added %attr.
- Removed noreplace.

* Sun Jan 19 2003 Gerald Dachs <gda at trustix dot org> 1.2.6-4gd
- rebuilt against openssl 0.9.7

* Thu Nov 21 2002 Christian H. Toldnes <christht at trustix dot com> 1.2.6-3ct
- initscript now uses $INITLOCK

* Thu Oct  3 2002 Christian H. Toldnes <christht at trustix dot com> 1.2.6-2ct
- Moved initscript to fit TSL 2.0

* Wed Sep 11 2002 Erlend Midttun <erlendbm at trustix dot com>
- Upgraded to 1.2.6
- Added TLS patch.

* Thu Jan  3 2002 Christian H. Toldnes <christht at trustix dot com>
- Upgraded to 1.2.4
- Chkconfig bug now fixed.
- General packages cleanup.

* Mon May 14 2001 Oystein Viggen <oysteivi at trustix dot com>
- configure does not use more than 1 --with-modules

* Wed Mar 28 2001 Alexander Reelsen <ar at trustix dot com>
- Short term security fix

* Tue Mar  6 2001 Oystein Viggen <oysteivi at trustix dot com>
- Update to v1.2.1

* Wed Feb 14 2001 Erlend Midttun <erlendbm at trustix dot com>
- Fixed typo in default config file.

* Fri Nov  3 2000 Erlend Midttun <erlendbm at trustix dot com>
- Trying to do ftpusers again.

* Tue Sep 12 2000 Per Ivar Paulsen <perp at trustix dot com>
- Updated to rc2

* Wed Jul 26 2000 Oystein Viggen <oysteivi at trustix dot com>
- Generate /etc/ftpusers during install

* Fri Mar 17 2000 Per Ivar Paulsen <perp at trustix dot com>
- Added better default configuration

* Mon Jan 24 2000 Per Ivar Paulsen <perp at trustix dot com>
- Initial release for the Trustix Secure Linux distribution.
- Added noreplace.
- Moved man and info pages to /usr/share adhering to FHS
- Picked up ProFTPd 1.2.0pre10

* Thu Oct 3 1999 O.Elliyasa <osman@Cable.EU.org>
- Multi package creation.
  Created core, standalone, inetd (&doc) package creations.
  Added startup script for init.d
  Need to make the "standalone & inetd" packages being created as "noarch"
- Added URL.
- Added prefix to make the package relocatable.

* Wed Sep 8 1999 O.Elliyasa <osman@Cable.EU.org>
- Corrected inetd.conf line addition/change logic.

* Sat Jul 24 1999 MacGyver <macgyver@tos.net>
- Initial import of spec.
